package permission

import "git.sxidc.com/go-framework/baize/framework/core/api/request"

type (
	CreatePermissionJsonBody struct {
		Name        string `json:"name" binding:"required" assign:"toField:Name"`
		Description string `json:"description" assign:"toField:Description"`
		Resource    string `json:"resource" binding:"required" assign:"toField:Resource"`
		Action      string `json:"action" binding:"required" assign:"toField:Action"`
	}

	DeletePermissionQueryParams struct {
		request.IDQueryParam
	}

	UpdatePermissionJsonBody struct {
		request.IDJsonBody
		Name        string `json:"name" assign:"toField:Name"`
		Description string `json:"description" assign:"toField:Description"`
		Resource    string `json:"resource" assign:"toField:Resource"`
		Action      string `json:"action" assign:"toField:Action"`
	}

	GetPermissionsQueryParams struct {
		request.BaseQueryParams
		Name     string `form:"name" assign:"toField:Name"`
		Resource string `form:"resource" assign:"toField:Resource"`
		Action   string `form:"action" assign:"toField:Action"`
	}

	GetPermissionQueryParams struct {
		request.IDQueryParam
	}

	UpdatePermissionGroupsOfPermissionJsonBody struct {
		request.IDJsonBody
		PermissionGroupIDs []string `json:"permissionGroupIds" assign:"toField:PermissionGroupIDs"`
	}

	GetPermissionGroupsOfPermissionQueryParams struct {
		request.BaseQueryWithIDParams
	}

	UpdateRolesOfPermissionJsonBody struct {
		request.IDJsonBody
		RoleIDs []string `json:"roleIds" assign:"toField:RoleIDs"`
	}

	GetRolesOfPermissionQueryParams struct {
		request.BaseQueryWithIDParams
	}
)
