package permission_group

import (
	"git.sxidc.com/go-framework/baize/framework/core/domain"
	"git.sxidc.com/go-framework/baize/framework/core/domain/entity"
)

const (
	FieldName        = "Name"
	FieldDescription = "Description"
)

var (
	ColumnName        = domain.ColumnName(FieldName)
	ColumnDescription = domain.ColumnName(FieldDescription)
)

var fieldMap = map[string]string{
	FieldName:        "权限组名称",
	FieldDescription: "权限组描述",
}

type Entity struct {
	entity.Base
	Name        string `sqlmapping:"column:name" sqlresult:"column:name" check:"required,lte=256,when=create/update"`
	Description string `sqlmapping:"column:description;updateClear" sqlresult:"column:description"`

	PermissionIDs []string `sqlmapping:"-" sqlresult:"-"`

	entity.UserIDFields
	entity.TimeFields
}

func (e *Entity) DomainCNName() string {
	return "权限组"
}

func (e *Entity) DomainCamelName() string {
	return "PermissionGroup"
}

func (e *Entity) GetFieldMap() map[string]string {
	return fieldMap
}
